'use strict';

var picasso = require('@dp/picasso');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = Object.setPrototypeOf ||
    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

// import * as OKNB from '@dp/knb';
// let KNB = OKNB.clone();
// KNB.setContext(context);
var selectedIdx = 0;
var tabs;
var showLoading = false;
var ParrotExtensionCoupon = /** @class */ (function (_super) {
    __extends(ParrotExtensionCoupon, _super);
    function ParrotExtensionCoupon() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ParrotExtensionCoupon.prototype.onLoad = function () {
        _super.prototype.onLoad.call(this);
    };
    ParrotExtensionCoupon.prototype.layout = function () {
        var _this = this;
        var container = picasso.View.viewWithFrame(0, 0, this.width, this.height);
        container.backgroundColor = "#EEEEEE";
        tabs = ["Tag1", "Tag1", "Tag2", "Tag3", "Tag4", "Tag5", "Tag6", "Tag7", "Tag8", "Tag9"];
        if (!tabs) {
            var indicator = picasso.ActivityIndicator.viewWithStyle(1 /* Large */);
            indicator.centerX = this.width / 2;
            indicator.centerY = this.height / 2;
            indicator.animating = true;
            container.addSubView(indicator);
        }
        else {
            var topTabView = buildTopTabContainerView(tabs, this.width, function () {
                // if (showLoading) {
                //     return
                // }
                // showLoading = true;
                // setTimeout(() => {
                //     showLoading = false;
                //     this.needLayout();
                // }, 2000);
                _this.needLayout();
            });
            container.addSubView(topTabView);
            if (showLoading) {
                var indicator = picasso.ActivityIndicator.viewWithStyle(1 /* Large */);
                indicator.centerX = this.width / 2;
                indicator.top = topTabView.bottom + 10;
                indicator.animating = true;
                container.addSubView(indicator);
            }
            else {
                var listView = picasso.ListView.viewWithFrame(0, topTabView.bottom, this.width, this.height - topTabView.height);
                listView.itemCount = 1000;
                listView.layoutItem = function (index) {
                    return buildListItem("x", index, _this.width);
                };
                listView.onItemClick = function (index) {
                    // KNB.alert({
                    //     title: 'Alert Title',
                    //     message: 'Alert content:'+index,
                    //     button: 'All right'
                    // });
                    // selectedIdx = index;
                    // log(index);
                    // this.needLayout();
                    picasso.log(index);
                };
                listView.backgroundColor = "#00FF00";
                container.addSubView(listView);
            }
        }
        return container;
    };
    return ParrotExtensionCoupon;
}(picasso.VC));
function buildTopTabContainerView(tabs, width, clickEvent) {
    var view = picasso.View.viewWithFrame(0, 0, width, 0);
    view.backgroundColor = "#00FFFFFF";
    var vSpace = 8;
    var hSpace = 15;
    var padding = 16;
    var left = padding;
    var top = padding;
    var height = 0;
    tabs.forEach(function (tab, idx) {
        var color = "#FFFFFF";
        var borderColor = "#DDDDDD";
        var borderWidth = 1;
        var textColor = "#666666";
        if (idx == selectedIdx) {
            color = "#FF6633";
            borderColor = "#00FFFFFF";
            borderWidth = 0;
            textColor = "#FFFFFF";
        }
        var textView = picasso.TextView.viewWithFrame(0, 0, 0, 0);
        textView.textSize = 16;
        textView.text = tab;
        textView.textColor = textColor;
        textView.textAlignment = 1 /* Center */;
        textView.cornerRadius = 18;
        textView.borderColor = borderColor;
        textView.backgroundColor = color;
        textView.borderWidth = borderWidth;
        textView.sizeToFitSync();
        textView.height = 32;
        textView.width += 32;
        if (left + textView.width + padding > width) {
            left = padding;
            top += (textView.height + vSpace);
        }
        textView.left = left;
        textView.top = top;
        left += (textView.width + hSpace);
        height = textView.bottom + padding;
        var viewIdx = idx;
        textView.onClick = function () {
            selectedIdx = viewIdx;
            clickEvent();
        };
        view.addSubView(textView);
    });
    var border = picasso.View.viewWithFrame(0, height - 1, width, 1);
    border.backgroundColor = "#E1E1E1";
    view.addSubView(border);
    view.height = height;
    return view;
}
function buildListItem(type, idx, width) {
    var listItem = picasso.ListItem.itemWithReuseId("ParrotCouponItem" + type);
    listItem.height = 50 * (selectedIdx + 1);
    var containerView = picasso.View.viewWithFrame(0, 0, width, 50);
    containerView.backgroundColor = "#FF00FF";
    listItem.addSubView(containerView);
    var textView = picasso.TextView.viewWithFrame(0, 0, 200, 30);
    textView.text = tabs[selectedIdx] + " " + idx;
    var i = idx;
    textView.onClick = function () {
        picasso.log(i);
    };
    containerView.addSubView(textView);
    return listItem;
}
Picasso.Page(ParrotExtensionCoupon);
